Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## SpaceTime.DataModel
Interface SpaceTimeNode

    public interface SpaceTimeNode

SpaceTimeNode is the primary data structure for storing space-time data. Nodes all have an identifier name, and an optional set of properties and edge properties. Passed by reference

Method Summary
`boolean` | `Active()` Active flag
`void` | `Active(boolean value)`
`void` | `AddChild(SpaceTimeNode child)` Inserts a child into the node tree.
`void` | `AddChildAt(SpaceTimeNode child, long index)` Inserts a child at the specified index.
`void` | `AddEdge(SpaceTimeEdge edge)` Adds a new non-isA edge to this node.
`void` | `AddEdgeProperty(java.lang.String edgeType, SpaceTimeProperty edgeProperty)` Adds an edge property to the specified edgeType
`void` | `AddProperty(SpaceTimeProperty property)` Adds a new property to this node.
`void` | `ApplyDefaultRules()` Apply default rules to the node
`boolean` | `DefaultRulesAllowed()` Default rules permission flag
`void` | `DefaultRulesAllowed(boolean value)`
`SpaceTimeNode` | `FindChild(java.lang.String childName)` Searches entire tree for node with name childName.
`void` | `FlushAllScores()` Flush scores of the node and all its children
`SpaceTimeDataAdapter` | `GetAdapter()` Returns the data adapter that created this node
`SpaceTimeNode` | `GetChild(long index)` Gets child at specified index
`int` | `GetChildrenCount()` Gets total number of children
`java.lang.String` | `GetDisplayName()` Gets the display name of the node
`SpaceTimeEdge` | `GetEdge(java.lang.String edgeType)` Find edge by type
`SpaceTimeEdge` | `GetEdgeAt(int index)` Returns edge at specified index
`int` | `GetEdgeCount()` Number of edges
`SpaceTimeProperty` | `GetEdgeProperty(java.lang.String edgeType, java.lang.String propertyType)` Helper to fetch an edge property value propertyType
`SpaceTimeProperty` | `GetLocalProperty(int index)` Gets the non-inherited property at index.
`int` | `GetLocalPropertyCount()` Gets the non-inherited property count
`long` | `GetParentIndex()` Returns the index of this node within the parent's child collection
`SpaceTimeProperty` | `GetProperty(java.lang.String name)` Gets property by name.
`DMArrayList` | `GetPropertyNames()` Gets all property names within this node
`SpaceTimeNode` | `GetRootParent()` Gets the highest node in the ancestors tree
`DMArrayList` | `GetUnassociatedPropertyNames()` Returns a list of unassociated property names
`boolean` | `IsA(java.lang.String name)` Checks if there is a node with specified name in the ancestors tree
`java.lang.String` | `Name()` Name
`void` | `NotifyChange()` Notify listeners of a change
`SpaceTimeNode` | `Parent()` Parent node
`SpaceTimeEdge` | `ParentEdge()` Parent isA edge
`void` | `ParentEdge(SpaceTimeEdge value)`
`void` | `Release()` Clears all properties and edges associated with this node and removes it from parent.
`void` | `RemoveEdge(java.lang.String edgeType)` Removes an edge by type
`void` | `ResetDefaultProperties()` Resets all properties defined by default rules
`double` | `Score()` Node's score
`void` | `Score(double value)`
`java.lang.String` | `ShownInGUI()` Optional attribute, can have 3 values: "true" "false" "default" Only room nodes can have this property (this is a semantic restriction and not a restriction enforced by the DTD/XSD)
`void` | `ShownInGUI(java.lang.String value)`
`java.lang.String` | `ToString()` Returns node name

Method Detail

### ToString

    java.lang.String ToString()

  Returns node name

### GetAdapter

    SpaceTimeDataAdapter GetAdapter()

  Returns the data adapter that created this node

### NotifyChange

    void NotifyChange()

  Notify listeners of a change

### AddChild

    void AddChild(SpaceTimeNode child)

  Inserts a child into the node tree.

### AddChildAt

    void AddChildAt(SpaceTimeNode child,
                    long index)

  Inserts a child at the specified index.

### FindChild

    SpaceTimeNode FindChild(java.lang.String childName)

  Searches entire tree for node with name childName.

### GetChildrenCount

    int GetChildrenCount()

  Gets total number of children

### GetDisplayName

    java.lang.String GetDisplayName()

  Gets the display name of the node

### GetRootParent

    SpaceTimeNode GetRootParent()

  Gets the highest node in the ancestors tree

### GetChild

    SpaceTimeNode GetChild(long index)

  Gets child at specified index

### GetUnassociatedPropertyNames

    DMArrayList GetUnassociatedPropertyNames()

  Returns a list of unassociated property names

### GetPropertyNames

    DMArrayList GetPropertyNames()

  Gets all property names within this node

### GetEdgeCount

    int GetEdgeCount()

  Number of edges

### GetLocalPropertyCount

    int GetLocalPropertyCount()

  Gets the non-inherited property count

### GetLocalProperty

    SpaceTimeProperty GetLocalProperty(int index)

  Gets the non-inherited property at index.

### GetProperty

    SpaceTimeProperty GetProperty(java.lang.String name)

  Gets property by name.

### IsA

    boolean IsA(java.lang.String name)

  Checks if there is a node with specified name in the ancestors tree

### ResetDefaultProperties

    void ResetDefaultProperties()

  Resets all properties defined by default rules

### ApplyDefaultRules

    void ApplyDefaultRules()

  Apply default rules to the node

### GetEdgeAt

    SpaceTimeEdge GetEdgeAt(int index)

  Returns edge at specified index

### GetEdge

    SpaceTimeEdge GetEdge(java.lang.String edgeType)

  Find edge by type

### GetEdgeProperty

    SpaceTimeProperty GetEdgeProperty(java.lang.String edgeType,
                                      java.lang.String propertyType)

  Helper to fetch an edge property value propertyType

### AddProperty

    void AddProperty(SpaceTimeProperty property)

  Adds a new property to this node.

### AddEdgeProperty

    void AddEdgeProperty(java.lang.String edgeType,
                         SpaceTimeProperty edgeProperty)

  Adds an edge property to the specified edgeType

### AddEdge

    void AddEdge(SpaceTimeEdge edge)

  Adds a new non-isA edge to this node.

### RemoveEdge

    void RemoveEdge(java.lang.String edgeType)

  Removes an edge by type

### FlushAllScores

    void FlushAllScores()

  Flush scores of the node and all its children

### Release

    void Release()

  Clears all properties and edges associated with this node and removes it from parent.

### GetParentIndex

    long GetParentIndex()

  Returns the index of this node within the parent's child collection

### Active

    boolean Active()

  Active flag

### Active

    void Active(boolean value)

### DefaultRulesAllowed

    boolean DefaultRulesAllowed()

  Default rules permission flag

### DefaultRulesAllowed

    void DefaultRulesAllowed(boolean value)

### Score

    double Score()

  Node's score

### Score

    void Score(double value)

### ShownInGUI

    java.lang.String ShownInGUI()

  Optional attribute, can have 3 values: "true" "false" "default" Only room nodes can have this property (this is a semantic restriction and not a restriction enforced by the DTD/XSD)

### ShownInGUI

    void ShownInGUI(java.lang.String value)

### Name

    java.lang.String Name()

  Name

### Parent

    SpaceTimeNode Parent()

  Parent node

### ParentEdge

    SpaceTimeEdge ParentEdge()

  Parent isA edge

### ParentEdge

    void ParentEdge(SpaceTimeEdge value)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD